﻿@model TimeLogManagement.UI.ViewModel.PageList<TimeLogManagement.DAL.Models.User>

<!DOCTYPE html>
<html>
<head>
    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
    <link rel="stylesheet" href="~/css/site.css" asp-append-version="true" />
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
</head>
<body>
    <div class="container">
        <div class="leftSide">
            <div class="grid">
                <table>
                    <tr>
                        <th>
                            <a asp-action="Index" asp-route-pageNumber="1" asp-route-sortOrder="name_asc" asp-route-startDate="@Model.StartDate" asp-route-endDate="@Model.EndDate" class="prevButton">Order By First Name ascending</a>
                        </th>
                        <th>
                            <a asp-action="Index" asp-route-pageNumber="1" asp-route-sortOrder="name_desc" asp-route-startDate="@Model.StartDate" asp-route-endDate="@Model.EndDate" class="prevButton">Order By First Name descending</a>
                        </th>
                        <th>
                            @using (Html.BeginForm("Index", "Home", FormMethod.Post))
                            {
                                <div>
                                    <div>
                                        <label for="startDate">Start date:</label>
                                        <input type="text" name="startDate" id="startDate" placeholder="Format: dd/mm/yyyy" value="@Model.StartDate" />

                                    </div>
                                    <div>
                                        <label for="endDate">End date:</label>
                                        <input type="text" name="endDate" id="endDate" placeholder="Format: dd/mm/yyyy" value="@Model.EndDate" />
                                    </div>
                                </div>
                                <div>
                                    <input type="submit" value="Sort By Dates" />
                                </div>
                            }
                        </th>
                        <th></th>
                    </tr>
                    <tr>
                        <th>First Name</th>
                        <th>Last Name</th>
                        <th>Email</th>
                        <th></th>
                    </tr>
                    @foreach (var user in Model)
                    {
                        <tr>
                            <td>@Html.DisplayFor(modelItem => user.FirstName)</td>
                            <td>@Html.DisplayFor(modelItem => user.LastName)</td>
                            <td>@Html.DisplayFor(modelItem => user.Email)</td>
                            <td class="buttonHolder" onclick="drawChartWithLine(@user.Id)"><button class="compareButton">Compare</button></td>
                        </tr>
                    }
                </table>
            </div>
            <br>
            <div class="gridButtons">
                @{
                    if (Model.HasPreviousPage)
                    {
                        <a asp-action="Index" asp-route-pageNumber="@(Model.PageIndex - 1)" asp-route-sortOrder=@Model.SortOrder asp-route-startDate="@Model.StartDate" asp-route-endDate="@Model.EndDate" class="prevButton">Previous</a>
                    }
                    if (Model.HasNextPage)
                    {
                        <a asp-action="Index" asp-route-pageNumber="@(Model.PageIndex + 1)" asp-route-sortOrder=@Model.SortOrder asp-route-startDate="@Model.StartDate" asp-route-endDate="@Model.EndDate" class="nextButton">Next</a>
                    }
                }
            </div>
        </div>
        <div class="rightSide">
            <div id="chart_div" style="width: 100%; height: 100%;"></div>
        </div>
    </div>
    <br>
    <div class="initializeButtonContainer">
        <button id="initializeButton">Initialize data</button>
    </div>
</body>
</html>

<script>
    google.charts.load('current', { 'packages': ['corechart'] });
    google.charts.setOnLoadCallback(drawChart);

    function getTopUsers(callback) {
        $.ajax({
            url: '/Home/LeftPanel',
            type: 'POST',
            data: { 'startDate': '@Model.StartDate', 'endDate': '@Model.EndDate' },
            success: function (data) {
                callback(data);
            },
            error: function (error) {
                console.log('Error occurred while trying to get top users', error);
            }
        });
    }

    function getUserById(callback, id) {
        $.ajax({
            url: '/Home/UserInfo?id=' + encodeURIComponent(id),
            type: 'GET',
            success: function (data) {
                callback(data);
            },
            error: function (error) {
                console.log('Error occurred while trying to get user by id', error);
            }
        });
    }

    function drawChartWithLine(userId) {
        getUserById(function (userData) {

            var userToCompare = userData;

            var data = new google.visualization.DataTable();
            data.addColumn('string', 'Users');
            data.addColumn('number', 'Hours');
            data.addColumn('number', userToCompare.fullName);

            getTopUsers(function (usersData) {

                users = usersData;

                if (users) {
                    for (var user of users) {
                        data.addRows([[user.fullName, user.totalWorkedHours, userToCompare.totalWorkedHours]])
                    }
                }

                var options = {
                    title: 'Top Users Ordered By Their Worked Hours',
                    legend: { position: 'none' },
                    hAxis: { title: 'Users' },
                    vAxis: { title: 'Total Worked Hours' },
                    width: 800,
                    height: 600,
                    seriesType: 'bars',
                    series: {
                        0: { color: '8FBC8B' },
                        1: { type: 'line', color: 'red', lineWidth: 5 }
                    }
                };

                var chart = new google.visualization.ComboChart(document.getElementById('chart_div'));
                chart.draw(data, options);
            });
        }, userId);
    }

    function drawChart() {

        getTopUsers(function (usersData) {

            users = usersData;

            var data = new google.visualization.DataTable();
            data.addColumn('string', 'Users');
            data.addColumn('number', 'Hours');

            if (users) {
                for (var user of users) {
                    data.addRows([[user.fullName, user.totalWorkedHours]])
                }
            }

            var options = {
                title: 'Top Users Ordered By Their Worked Hours',
                legend: { position: 'none' },
                hAxis: { title: 'Users' },
                vAxis: { title: 'Total Worked Hours' },
                width: 800,
                height: 600,
                colors: ['#8FBC8B']
            };

            var chart = new google.visualization.ColumnChart(document.getElementById('chart_div'));
            chart.draw(data, options);
        });
    }

    $(document).ready(function () {
        $("#initializeButton").click(function () {
            $.ajax({
                url: '/Home/InitializeData',
                success: function () {
                    alert('Successfully added data!');
                    window.location.reload();
                },
                error: function () {
                    alert('Error occurred while trying initialize data');
                }
            });
        });
    });
</script>


